// Code generated by protoc-gen-go-grpc. DO NOT EDIT.

package freeje_admin

import (
	context "context"
	api "gitlab.com/BetaCompany/Freeje/sdk/go/api"
	grpc "google.golang.org/grpc"
	codes "google.golang.org/grpc/codes"
	status "google.golang.org/grpc/status"
)

// This is a compile-time assertion to ensure that this generated file
// is compatible with the grpc package it is being compiled against.
// Requires gRPC-Go v1.32.0 or later.
const _ = grpc.SupportPackageIsVersion7

// VoipClient is the client API for Voip service.
//
// For semantics around ctx use and closing/ending streaming RPCs, please refer to https://pkg.go.dev/google.golang.org/grpc/?tab=doc#ClientConn.NewStream.
type VoipClient interface {
	//
	// Получить текущее состояние сердцебиения всех инстансов Freeswitch
	// и продолжать мониторинг streamed=1
	GetFreeswitchHeartbeat(ctx context.Context, in *api.RequestMode, opts ...grpc.CallOption) (Voip_GetFreeswitchHeartbeatClient, error)
	//
	// Получить текущее состояние вызовов и продолжать мониторинг streamed=1
	GetActiveCalls(ctx context.Context, in *api.RequestMode, opts ...grpc.CallOption) (Voip_GetActiveCallsClient, error)
}

type voipClient struct {
	cc grpc.ClientConnInterface
}

func NewVoipClient(cc grpc.ClientConnInterface) VoipClient {
	return &voipClient{cc}
}

func (c *voipClient) GetFreeswitchHeartbeat(ctx context.Context, in *api.RequestMode, opts ...grpc.CallOption) (Voip_GetFreeswitchHeartbeatClient, error) {
	stream, err := c.cc.NewStream(ctx, &Voip_ServiceDesc.Streams[0], "/com.freeje.api.admin.Voip/GetFreeswitchHeartbeat", opts...)
	if err != nil {
		return nil, err
	}
	x := &voipGetFreeswitchHeartbeatClient{stream}
	if err := x.ClientStream.SendMsg(in); err != nil {
		return nil, err
	}
	if err := x.ClientStream.CloseSend(); err != nil {
		return nil, err
	}
	return x, nil
}

type Voip_GetFreeswitchHeartbeatClient interface {
	Recv() (*FreeswitchHeartbeat, error)
	grpc.ClientStream
}

type voipGetFreeswitchHeartbeatClient struct {
	grpc.ClientStream
}

func (x *voipGetFreeswitchHeartbeatClient) Recv() (*FreeswitchHeartbeat, error) {
	m := new(FreeswitchHeartbeat)
	if err := x.ClientStream.RecvMsg(m); err != nil {
		return nil, err
	}
	return m, nil
}

func (c *voipClient) GetActiveCalls(ctx context.Context, in *api.RequestMode, opts ...grpc.CallOption) (Voip_GetActiveCallsClient, error) {
	stream, err := c.cc.NewStream(ctx, &Voip_ServiceDesc.Streams[1], "/com.freeje.api.admin.Voip/GetActiveCalls", opts...)
	if err != nil {
		return nil, err
	}
	x := &voipGetActiveCallsClient{stream}
	if err := x.ClientStream.SendMsg(in); err != nil {
		return nil, err
	}
	if err := x.ClientStream.CloseSend(); err != nil {
		return nil, err
	}
	return x, nil
}

type Voip_GetActiveCallsClient interface {
	Recv() (*ActiveCall, error)
	grpc.ClientStream
}

type voipGetActiveCallsClient struct {
	grpc.ClientStream
}

func (x *voipGetActiveCallsClient) Recv() (*ActiveCall, error) {
	m := new(ActiveCall)
	if err := x.ClientStream.RecvMsg(m); err != nil {
		return nil, err
	}
	return m, nil
}

// VoipServer is the server API for Voip service.
// All implementations should embed UnimplementedVoipServer
// for forward compatibility
type VoipServer interface {
	//
	// Получить текущее состояние сердцебиения всех инстансов Freeswitch
	// и продолжать мониторинг streamed=1
	GetFreeswitchHeartbeat(*api.RequestMode, Voip_GetFreeswitchHeartbeatServer) error
	//
	// Получить текущее состояние вызовов и продолжать мониторинг streamed=1
	GetActiveCalls(*api.RequestMode, Voip_GetActiveCallsServer) error
}

// UnimplementedVoipServer should be embedded to have forward compatible implementations.
type UnimplementedVoipServer struct {
}

func (UnimplementedVoipServer) GetFreeswitchHeartbeat(*api.RequestMode, Voip_GetFreeswitchHeartbeatServer) error {
	return status.Errorf(codes.Unimplemented, "method GetFreeswitchHeartbeat not implemented")
}
func (UnimplementedVoipServer) GetActiveCalls(*api.RequestMode, Voip_GetActiveCallsServer) error {
	return status.Errorf(codes.Unimplemented, "method GetActiveCalls not implemented")
}

// UnsafeVoipServer may be embedded to opt out of forward compatibility for this service.
// Use of this interface is not recommended, as added methods to VoipServer will
// result in compilation errors.
type UnsafeVoipServer interface {
	mustEmbedUnimplementedVoipServer()
}

func RegisterVoipServer(s grpc.ServiceRegistrar, srv VoipServer) {
	s.RegisterService(&Voip_ServiceDesc, srv)
}

func _Voip_GetFreeswitchHeartbeat_Handler(srv interface{}, stream grpc.ServerStream) error {
	m := new(api.RequestMode)
	if err := stream.RecvMsg(m); err != nil {
		return err
	}
	return srv.(VoipServer).GetFreeswitchHeartbeat(m, &voipGetFreeswitchHeartbeatServer{stream})
}

type Voip_GetFreeswitchHeartbeatServer interface {
	Send(*FreeswitchHeartbeat) error
	grpc.ServerStream
}

type voipGetFreeswitchHeartbeatServer struct {
	grpc.ServerStream
}

func (x *voipGetFreeswitchHeartbeatServer) Send(m *FreeswitchHeartbeat) error {
	return x.ServerStream.SendMsg(m)
}

func _Voip_GetActiveCalls_Handler(srv interface{}, stream grpc.ServerStream) error {
	m := new(api.RequestMode)
	if err := stream.RecvMsg(m); err != nil {
		return err
	}
	return srv.(VoipServer).GetActiveCalls(m, &voipGetActiveCallsServer{stream})
}

type Voip_GetActiveCallsServer interface {
	Send(*ActiveCall) error
	grpc.ServerStream
}

type voipGetActiveCallsServer struct {
	grpc.ServerStream
}

func (x *voipGetActiveCallsServer) Send(m *ActiveCall) error {
	return x.ServerStream.SendMsg(m)
}

// Voip_ServiceDesc is the grpc.ServiceDesc for Voip service.
// It's only intended for direct use with grpc.RegisterService,
// and not to be introspected or modified (even as a copy)
var Voip_ServiceDesc = grpc.ServiceDesc{
	ServiceName: "com.freeje.api.admin.Voip",
	HandlerType: (*VoipServer)(nil),
	Methods:     []grpc.MethodDesc{},
	Streams: []grpc.StreamDesc{
		{
			StreamName:    "GetFreeswitchHeartbeat",
			Handler:       _Voip_GetFreeswitchHeartbeat_Handler,
			ServerStreams: true,
		},
		{
			StreamName:    "GetActiveCalls",
			Handler:       _Voip_GetActiveCalls_Handler,
			ServerStreams: true,
		},
	},
	Metadata: "admin/voip.proto",
}
